#include "WProgram.h"
#define DATA_PIN 13
#define CLOCK_PIN 12
#define LATCH_PIN 11

void setup();
void loop();
void send8Bit(int val);
void setup()
{
  pinMode(DATA_PIN, OUTPUT);
  pinMode(CLOCK_PIN, OUTPUT);
  pinMode(LATCH_PIN, OUTPUT);
  
  Serial.begin(9600);
}

void loop()
{
  int i;
  
  for (int i = 0; i < 8; i++)
  {
    send8Bit(1 << i);
    delay(30);
  }
  delay(40);
  
  for (int i = 0; i < 8; i++)
  {
    send8Bit(1 << (7-i));
    delay(30);
  }
  delay(40);
}

void send8Bit(int val)
{
  for (byte i = 0; i < 8; i++)
  {
    digitalWrite(CLOCK_PIN, LOW);
    
    // bit ausgeben (oberstes bit)
    if (val & 0b10000000) 
      digitalWrite(DATA_PIN, HIGH);
    else
      digitalWrite(DATA_PIN, LOW);
    
    // steigende flanke von clock sagt dem schieberegister, dass es das bit einlesen soll
    digitalWrite(CLOCK_PIN, HIGH);
    
    // bits um eins weiterschieben
    val <<= 1;
  }
  
  // Latch
  digitalWrite(LATCH_PIN, HIGH);
  digitalWrite(LATCH_PIN, LOW); 
}

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

