/**
 * controll programm for the RGB led 
 * copzleft by Philipp Tiewfenbacher
 */

import processing.serial.*;


int colors = 3;
int mode_sin = 1;
int mode_sin2 = 2;

float val;
int modes[];
float angles[];
color cols[];
HScrollbar Values[];
HScrollbar Frequ[];

int buttons = 2;
CircleButton myButtons[]; 

//circle2 = new CircleButton(x, y, size, buttoncolor, highlight);

Serial port;


void setup()
{
  size(750, 170);
  
  
  
  // Print a list in case COM1 doesn't work out
  println("Available serial ports:");
  println(Serial.list());

  //port = new Serial(this, "COM1", 9600);
  // Uses the first available port
  port = new Serial(this, Serial.list()[2], 9600);
  
  
  cols = new color[colors];
  cols[0] = color(255, 0, 0);
  cols[1] = color(0, 255, 0);
  cols[2] = color(0, 0, 255);
  
  Values = new HScrollbar[colors];
  Frequ = new HScrollbar[colors];
  angles = new float[colors];
  modes = new int[colors];
  
  int c;
  for (c = 0; c < colors; c++) {
    angles[c] = 0.0;
    Values[c] = new HScrollbar(0, 30 + c*50, 254, 30, cols[c]);
    Frequ[c] = new HScrollbar(300, 30 + c*50, 200, 30, cols[c]);
    Values[c].setPos(0);
    Frequ[c].setPos(0);
    modes[c] = mode_sin2;
  }
  
  myButtons = new CircleButton[buttons*colors];
  
  int bnr;
  int b = 0;
  for (bnr = 0; bnr < buttons; bnr++) {
    for (c = 0; c < colors; c++) {
      myButtons[b] =  new CircleButton(530+bnr*40, 30+c*50, 25, color(150), color(200, 200, 200));
      b++;
    }
  }
}

void draw()
{
  background(100);
  
  update(mouseX, mouseY);
  
  port.write(255);
  for (int c = 0; c < colors; c++) {
    Values[c].update();
    Values[c].draw();
    Frequ[c].update();
    Frequ[c].draw();
    if (Frequ[c].getPos() < 0.1) {
      port.write((byte)Values[c].getPos());
      angles[c] = 0.0;
    }
    else {
      if (modes[c] == mode_sin2)
      {
          val = (Values[c].getPos() * (cos(angles[c])+0.3)/1.3);
          if (val < 0) val = 0;
      }
      else if (modes[c] == 22)
      {
          val = (Values[c].getPos() * (cos(angles[c])+1)/2.0);
      }
      else 
      {
         val = cos(angles[c]);
          if (val < 0)
            val = 0;
          val *= Values[c].getPos();
      }
      port.write((byte)val);
      angles[c] += exp((Frequ[c].getPos()-200)/50.0);
      if (angles[c] > 2*PI) {
        angles[c] -= 2*PI;
      }
    } 
  }
}

///*
void update(int x, int y)
{
  int b, c, bnr;
  if(locked == false) {
   for (b = 0; b < colors*buttons; b++) {
     myButtons[b].update();
     myButtons[b].display();
   }
  } 
  else {
    locked = false;
  }
  
  if(mousePressed) {
    b = 0;
    for (bnr = 0; bnr < buttons; bnr++) {
      for (c = 0; c < colors; c++) {
        if (myButtons[b].pressed()) {
          switch (bnr) {
            case 0:
              breakBlink(c);
              break;
            case 1:
              switch (c) {
                case 0:
                  breakBlink(3);
                  break;
                case 1:
                  rgbblink();
                  break;
              } 
              break;
          }
        }
        b++;
      }
    }
  }
}

void sendCol(int r, int g, int b) {
  if (r >= 255)
    r = 254;
  if (g >= 255)
    g = 254;
  if (b >= 255)
    b = 254;
    
  port.write(255);
  port.write(r);
  port.write(g);
  port.write(b);
}

void pause(int t1) {
  for (int t = 0; t < t1; t++) {
    millis();
  }
} 


void rgbblink() {
  for (int i = 0; i < 5; i++) {
    sendCol(255, 0, 0);
    pause(2000000);
    sendCol(0, 255, 0);
    pause(2000000);
    sendCol(0, 0, 255);
    pause(2000000);
  }
}


void breakBlink(int col) {
  int r, g, b;
  
  r = col ==  0 ? 254 : 0;
  g = col ==  1 ? 254 : 0;
  b = col ==  2 ? 254 : 0;
  
  if (col == 3)
    r = g = b = 254;
  
  
  if ((int)random(2) == 1) {
    sendCol(r/5, g/5, b/5);
    sendCol(0, 0, 0);
    pause(1000000);
  }
  
  if ((int)random(2) == 1) {
    for (int i = 0;  i < 5; i++) {
      sendCol(r/20, g/20, b/20);
      sendCol(0, 0, 0);
    }
  }
  
  if ((int)random(2) == 1) {
    sendCol(r/2, g/2, b/2);
    sendCol(0, 0, 0);
    pause(1400000);
  }
  
  if ((int)random(2) == 1) {
    for (int i = 0;  i < 6; i++) {
      sendCol(r/15, g/15, b/15);
      sendCol(0, 0, 0);
    }
  }
  
  if ((int)random(2) == 1) {
    sendCol(r/2, g/2, b/2);
    sendCol(0, 0, 0);
    pause(1400000);
  }
  
  if ((int)random(2) == 1) {
    for (int i = 0;  i < 7; i++) {
      sendCol(r/12, g/12, b/12);
      sendCol(0, 0, 0);
    }
  }
  
  if ((int)random(2) == 1) {
    sendCol(r, g, b);
    sendCol(0, 0, 0);
    pause(3000000);
  }
  
  if ((int)random(2) == 1) {
    for (int i = 0;  i < 4; i++) {
      sendCol(r/3, g/3, b/3);
      sendCol(0, 0, 0);
     //pause(100);
    }
  }
  
  sendCol(r, g, b);
  Values[0].setPos(r);
  Values[1].setPos(g);
  Values[2].setPos(b);
}

void breakBlink2(int col) {
  int r, g, b;
  
  r = col ==  0 ? 255 : 0;
  g = col ==  1 ? 255 : 0;
  b = col ==  2 ? 255 : 0;
  
  r = g = b = 255;
  
  sendCol(r/5, g/5, b/5);
  sendCol(0, 0, 0);
  
  pause(1000000);
  
  for (int i = 0;  i < 3; i++) {
    sendCol(r/20, g/20, b/20);
    sendCol(0, 0, 0);
    pause(100000);
  }
  
  sendCol(r/2, g/2, b/2);
  sendCol(0, 0, 0);
  
 /*
pause(1400000);
  
  for (int i = 0;  i < 4; i++) {
    sendCol(r/15, g/15, b/15);
    sendCol(0, 0, 0);
    pause(100000);
  }
  
  sendCol(r/2, g/2, b/2);
  sendCol(0, 0, 0);
//*/  

  pause(1400000);
  
  for (int i = 0;  i < 3; i++) {
    sendCol(r/30, g/30, b/30);
    sendCol(r/60, r/60, r/60);
    pause(120000);
  }
  
  sendCol(r, g, b);
  sendCol(0, 0, 0);
  
  pause(3000000);
  
  for (int i = 0;  i < 4; i++) {
    sendCol(r/3, g/3, b/3);
    sendCol(r/40, r/40, r/40);
    //pause(100);
  }
  
  sendCol(r, g, b);
  for (int cc = 0; cc < colors; cc++) {
    //if (cc == c)
      Values[cc].setPos(254);
    //else
    //  Frequ[c].setPos(0);
  }
}

//*/
